package genj.app;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Class which provides some static helpers for JButtons
 */
public class ButtonHelper  {

  /**
   * Helper that creates a button
   */
  static public JButton createButton(String label, ImageIcon img, String action, ActionListener listener) {
	return createButton(label,img,action,listener,true,true);
  }      
  /**
   * Helper that creates a button
   */
  static public JButton createButton(String label, ImageIcon img, String action, ActionListener listener, boolean enabled) {
	return createButton(label,img,action,listener,enabled,true);
  }      
  /**
   * Helper that creates a button
   */
  static public JButton createButton(String label, ImageIcon img, String action, ActionListener listener, boolean enabled, boolean margin) {

	JButton result = new JButton();
	if (label!=null)
	  result.setText(label);
	if (img!=null)
	  result.setIcon(img);
	if (action!=null)
	  result.setActionCommand(action);
	if (listener!=null)
	  result.addActionListener(listener);
	if (!margin)
	  result.setMargin(new Insets(0,0,0,0));

	result.setEnabled(enabled);

	return result;
  }      
}