package genj.app;

import javax.help.*;
import java.net.*;
import java.util.*;
import java.io.*;

import genj.util.Registry;

/**
 * A bridge to Swing's Help System
 * Creation date: (10/20/00 10:20:27 AM)
 * @author: 
 */
class HelpBridgeImpl implements HelpBridge {

	private HelpBroker broker;

public void close(Registry registry) {

	if (broker==null)
		return;
		
	registry.put("help",broker.getSize());
	registry.put("help",broker.getLocation());
	
}
/**
 * Opens the help
 */
public void open(Registry registry) {

	if (broker!=null) {
		broker.setSize(broker.getSize());
		broker.setLocation(broker.getLocation());
		broker.setDisplayed(true);
		return;
	}
	
	String prefix = System.getProperty("user.dir") + "/" + "help",
	       postfix= "/helpset.xml";
	HelpSet hs=null;

	try {
		Locale locale = Locale.getDefault();
		String file = prefix+"_"+locale.getLanguage()+postfix;
		if (!new File(file).exists()) {
			System.out.println("Tried to find help for locale " + locale + " in " + file );
			file = prefix+postfix;
		}
		if (!new File(file).exists()) {
			System.out.println("Tried to find help in " + file + " ... sorry :(" );
			return;
		}
		System.out.println("Trying help in " + file );
		URL url = new URL("file","", file);
		hs = new HelpSet(null,url);
	} catch (Exception e1) {
	}

	broker = hs.createHelpBroker();
	broker.setSize(registry.get("help",new java.awt.Dimension(640,480)));
	broker.setLocation(registry.get("help",new java.awt.Point(0,0)));
	broker.setDisplayed(true);
}
}
