package genj.app;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.lang.reflect.Method;

import javax.swing.*;
import javax.swing.event.*;




import genj.gedcom.*;import genj.util.ImgIcon;/**
 * Component for selecting  TagPaths by clicking on items in  alist
 */
public class TagPathList extends JComponent {

  private JList lChoose;
  private Vector vPaths;

  /**
   * Tag List Cell Renderer
   */
  class TagPathRenderer implements ListCellRenderer {

	private JLabel  label = new JLabel();
	private boolean selected;
		
	/**
	 * Return component for rendering list element
	 */
	public Component getListCellRendererComponent(JList list,Object value,int index,boolean isSelected,boolean cellHasFocus) {

	  TagPath path = (TagPath)value;

	  label.setText( path.toString() );
	  label.setIcon( Property.calcDefaultImage(path.getLast()).getImageIcon() );

	  if (isSelected)
		label.setBackground(lChoose.getSelectionBackground());
	  else
		label.setBackground(lChoose.getBackground());
	  label.setOpaque(isSelected);

	  return label;
	}
  }
  

  /**
   * Constructor
   */
  public TagPathList() {

	// Layout
	lChoose = new JList();
	lChoose.setCellRenderer(new TagPathRenderer());
	lChoose.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

	setLayout(new BorderLayout());
	add(new JScrollPane(lChoose),"Center");

	// Done	
  }      
  /**
   * Adds a path to this list
   */
  public void addPath(TagPath path) {

	if (vPaths==null)
	  vPaths = new Vector();

	vPaths.addElement(path);

	lChoose.setListData(vPaths);
  }      
  /**
   * Moves currently selected paths down
   */
  public void down() {

	// Find out which row is selected now
	int row = lChoose.getSelectedIndex();
	if ((row==-1)||(row==vPaths.size()-1))
	  return;

	// Move it down
	Object o = vPaths.elementAt(row);
	vPaths.setElementAt(vPaths.elementAt(row+1),row);
	vPaths.setElementAt(o,row+1);

	// Show it
	lChoose.setListData(vPaths);
	lChoose.setSelectedIndex(row+1);
  }      
  /**
   * Returns the paths used by this list
   */
  public TagPath[] getPaths() {

	if (vPaths==null)
	  return new TagPath[0];

	TagPath[] result = new TagPath[vPaths.size()];
	vPaths.copyInto(result);

	return result;
  }      
  /**
   * Returns the preferred size of this component
   */
  public Dimension getPreferredSize() {
	return new Dimension(64,64);
  }      
  /**
   * Removes a path from this list
   */
  public void removePath(TagPath path) {

	if (vPaths==null)
	  return;

	vPaths.removeElement(path);

	lChoose.setListData(vPaths);
  }      
  /**
   * Sets the paths used by this list
   */
  public void setPaths(TagPath[] paths) {

	vPaths = new Vector(paths.length);
	for (int p=0;p<paths.length;p++)
	  vPaths.addElement(paths[p]);

	lChoose.setListData(vPaths);

  }      
  /**
   * Moves currently selected paths up
   */
  public void up() {

	// Find out which row is selected now
	int row = lChoose.getSelectedIndex();
	if ((row==-1)||(row==0))
	  return;

	// Move it up
	Object o = vPaths.elementAt(row);
	vPaths.setElementAt(vPaths.elementAt(row-1),row);
	vPaths.setElementAt(o,row-1);

	// Show it
	lChoose.setListData(vPaths);
	lChoose.setSelectedIndex(row-1);
  }      
}