package genj.app;




import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

import java.awt.*;
import java.util.*;
import java.awt.event.*;


import genj.gedcom.*;import genj.util.*;/**
 * Class for editing the properties of a view
 */
class ViewEditor extends JPanel implements ViewInfo {

  static private ViewEditor instance = null;
  static private JLabel lDefault = new JLabel("- please select view -",JLabel.CENTER);
  static private Hashtable hViewInfos = new Hashtable();

  private TitledBorder border;
  private Frame frame;
  private JPanel pSettings;
  private JButton bApply,bReset,bClose;

  private Component view;
  private ViewInfo  info;

  /**
   * Constructor
   */
  ViewEditor(Frame pFrame) {

	frame = pFrame;

	// Panel for Views settings
	pSettings = new JPanel();
	border = BorderFactory.createTitledBorder("");
	pSettings.setBorder(border);

	// Panel for Actions
	JPanel pActions = new JPanel();

	ActionListener alistener = new ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		if ("CLOSE".equals(e.getActionCommand()))
		  frame.dispose();
		if ("APPLY".equals(e.getActionCommand())&&(view!=null))
		  info.apply();
		if ("RESET".equals(e.getActionCommand())&&(view!=null))
		  info.reset();
	  }
	};

	bApply = ButtonHelper.createButton("Apply",null,"APPLY", alistener, true, true);
	bReset = ButtonHelper.createButton("Reset",null,"RESET", alistener, true, true);
	bClose = ButtonHelper.createButton("Close",null,"CLOSE", alistener, true, true);

	pActions.add(bApply);
	pActions.add(bReset);
	pActions.add(bClose);

	// Layout
	setLayout(new BorderLayout());
	add(pSettings,"Center");
	add(pActions ,"South" );

	// Done
	setEditingComponent(this,null,null);
  }      
  /**
   * Remembers this instance
   */
  public void addNotify() {
	instance = this;
	super.addNotify();
  }      
  public void apply() {}      
  /**
   * Static signal that a view should not be edited anymore
   */
  static public void dontEdit(Component view) {

	// Instance there?
	if ((instance==null)||(instance.view!=view))
	  return;

	// .. turn to non editing
	instance.setEditingComponent(instance,null,null);
  }      
  /**
   * Static signal that a view should be edited
   */
  static public void edit(Component view, String title) {

	// Instance there?
	if ((instance==null)||(instance.view==view))
	  return;

	// Calculate class to use and instantiate it
	ViewInfo info = null;

	String viName = view.getClass().getName()+"Info";

	info = (ViewInfo)hViewInfos.get(viName);
	if (info==null) {
	  try {
		Class c = Class.forName(viName);
		info = (ViewInfo)c.newInstance();
		hViewInfos.put(viName,info);
	  } catch (ClassCastException cce) {
		System.out.println("[Debug]"+viName+" is no valid ViewInfo class");
	  } catch (Exception e) {
		System.out.println("[Debug] Couldnt instantiate "+viName);
	  }
	}

	// Minimum is default
	if (info==null)
	  info = instance;

	instance.setEditingComponent(info,view,title);

	// Done
  }        
  /**
   * Our editor component in case of missing ViewInfo
   */
  public Component getEditor() {
	return lDefault;
  }      
  /**
   * Forgets this instance
   */
  public void removeNotify() {
	instance = null;
	super.removeNotify();
  }      
  public void reset() {}      
  /**
   * Helper for adding an editing component
   */
  private void setEditingComponent(ViewInfo info,Component view, String title) {

	Component editor = info.getEditor();

	// Remove last
	pSettings.removeAll();

	// Add new
	if (title!=null) {
	  int i = title.indexOf('/');
	  if (i>0)
		title = title.substring(0,i);
	}
	border.setTitle(title);
	pSettings.setLayout(new BorderLayout());
	pSettings.add(editor,"Center");
	editor.setVisible(true);

	// Change Buttons
	bApply.setEnabled(view!=null);
	bReset.setEnabled(view!=null);

	// Now tell ViewInfo to talk about View
	info.setView(view);

	// Show it
	frame.pack();
	pSettings.invalidate();
	pSettings.repaint();

	// Remember
	this.view = view;
	this.info = info;
  }      
  public void setView(Component comp) {
  }      
}