package genj.app;

import java.awt.*;

/**
 * Interface between ViewEditor and XXXViewInfo classes
 */
public interface ViewInfo {

  /**
   * Tells the ViewInfo to apply made changes
   */
  public void apply();      
  /**
   * Has to return the component used for editing
   */
  public Component getEditor();      
  /**
   * Tells the ViewInfo to reset made changes
   */
  public void reset();      
  /**
   * Initializes this ViewInfo with the given View
   */
  public void setView(Component comp) throws IllegalArgumentException;      
}