package genj.applet;

import java.applet.*;
import java.net.*;

import genj.gedcom.*;

/**
 * GenJ Applet bridge to browser
 */
public class DetailBridge implements GedcomListener {

	private AppletContext ctx;
	private String url;

public DetailBridge(Applet applet, String url) {

	// Remember the context
	this.ctx = applet.getAppletContext();

	// Check the url
	if (!url.endsWith("/")) {
		url = url + "/";
	}
	if (url.indexOf(':')<0) {
		String base = applet.getDocumentBase().toString();
		int p = base.lastIndexOf('/');
		url = base.substring(0,p+1)+url;
	}

	// .. and remember
	this.url = url;

	// Done
}
/**
 * Notification about change in Gedcom
 */
public void handleChange(Change change) {
	// does not apply for applet
}
/**
 * Notification about closing Gedcom
 */
public void handleClose(Gedcom gedcom) {
	// does not apply for applet
}
/**
 * Notification about selection
 */
public void handleSelection(Selection selection) {

	String id = selection.getEntity().getId();
	String doc = url+id+".html";
	
	try {
		ctx.showDocument(new URL(doc),"_detail");
		System.out.println("Showing detail document "+doc);
	} catch (Exception e) {
		System.out.println("Couldn't show detail document "+doc);
	}
	
}
}
