package genj.edit;

import javax.swing.*;
import javax.swing.filechooser.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Vector;




import genj.gedcom.*;import genj.util.*;/** 
 * Proxy for editing GEDCOM-Property Blob
 */
class ProxyBlob extends Proxy implements ActionListener {

  private EditView     edit;
  private Frame        frame;
  private JLabel       lImage;
  private JScrollPane  sImage;
  
  /**
   * User pressed button to select file
   */
  public void actionPerformed(ActionEvent e) {
	
	// Let the user choose a file
	JFileChooser chooser = new JFileChooser(".");
	chooser.setDialogTitle("Choose a multimedia file");
	
	int rc=chooser.showDialog(frame, "Open");
	
	// Cancel ?
	if (JFileChooser.APPROVE_OPTION != rc)
	  return;

	// Can I write ?
	Gedcom gedcom = prop.getGedcom();
	if (!gedcom.startTransaction()) {
		return;
	}
	
	// Change blob-data to file-data
	File file = chooser.getSelectedFile();
	try {
	  ((PropertyBlob)prop).setValue(file);
	} catch (GedcomException ex) {
	  // .. message to user
	  JOptionPane.showMessageDialog(
		frame,
		ex.getMessage(),
		edit.resources.getString("error"),
		JOptionPane.ERROR_MESSAGE
	  );
	  // .. done for now
	}

	// Done
	gedcom.endTransaction();
	
	// Let it show
	showBlob();

  }      
  /**
   * Finish editing a property through proxy
   */
  protected void finish() {
	// Done
  }      
  /**
   * Returns change state of proxy
   */
  protected boolean hasChanged() {
	return false;
  }      
  /**
   * Shows property's image if possible
   */
  private void showBlob() {
	
	PropertyBlob pBlob = (PropertyBlob)prop;
	if (pBlob.getBlobData()==null) {
	  lImage.setText("No data stored here");
	  lImage.setIcon(null);
	} else {
	  // Image from Blob?
	  ImgIcon i = pBlob.getValueAsIcon();
	  ImageIcon icon = (i==null ? null : i.getImageIcon());
	  if ( (icon==null)||(icon.getIconWidth()<1)||(icon.getIconHeight()<1) ) {
		lImage.setText("Blob is no image");
		lImage.setIcon(null);
	  } else {
		lImage.setIcon(icon);
		lImage.setText("");
	  }
	}

	lImage.invalidate();
	sImage.validate();
  }      
  
  /**
   * Start editing a property through proxy
   */
  protected void start(JPanel in, JLabel setLabel, Property setProp, EditView setEdit) {

	edit =setEdit   ;
	prop =setProp   ;
	frame=edit.frame;

	// Add a button for FileChooserAction
	JButton bFile = new JButton("Choose File");
	bFile.addActionListener(this);
	in.add(bFile);
	
	// Any graphical information that could be shown ?
	lImage = new JLabel();
	lImage.setHorizontalAlignment(SwingConstants.CENTER);
	sImage = new JScrollPane(lImage);
	sImage.setMinimumSize(new Dimension(0,0));
	in.add(sImage);

	showBlob();

	// Done
  }      }