package genj.edit;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;




import genj.util.DateEntry;import genj.gedcom.*;/** 
 * Proxy for editing GEDCOM-Property Date
 */
class ProxyDate extends Proxy implements ItemListener {

  private boolean formatChanged = false;	
  private int currentDate;
  private JComboBox combo;
  private DateEntry deOne, deTwo;
  
  private static final boolean drange[] = {
	false,
	true,
	false,
	false,
	true,
	false,
	false,
	false,
	false,
	false
  };

  /**
   * Finish proxying edit for property Date
   */
  protected void finish() {

	// Something changed ?
	if (!hasChanged()) {
	  return;
	}
	
	PropertyDate p = (PropertyDate)prop; 
	  
	// Remember format
	p.setFormat(combo.getSelectedIndex());
			 
	// Remember One
	p.setValue(0,deOne.getDay(),deOne.getMonth(),deOne.getYear());

	// Remember Two    
	if ( p.isRange() )
	  p.setValue(1,deTwo.getDay(),deTwo.getMonth(),deTwo.getYear());
	  
	// Done
  }      
  /**
   * Returns change state of proxy
   */
  protected boolean hasChanged() {
	return ( (deOne.hasChanged()) || (deTwo.hasChanged()) || (formatChanged) );
  }      
  /**
   * Trigger for changes in editing components
   */
  public void itemStateChanged(ItemEvent e)	{

	formatChanged = true;
	
	if (PropertyDate.isRange(combo.getSelectedIndex()))
	  deOne.getParent().add(deTwo);
	else
	  deOne.getParent().remove(deTwo);

	deOne.getParent().invalidate();
	deOne.getParent().validate();
	// Done
  }      
  
  /**
   * Starts Proxying edit for property Date by filling a vector with
   * components to edit this property
   */
  protected void start(JPanel in, JLabel setLabel, Property setProp, EditView edit) { 

	prop=setProp;
	PropertyDate p = (PropertyDate)prop;

	// Components 
	combo = new JComboBox(); 
	combo.setAlignmentX(0);
	combo.setEditable(false);
	
	for (int i=0;i<PropertyDate.MAX;i++)
	  combo.addItem(PropertyDate.getLabelForFormat(i));
	in.add(combo);
	combo.addItemListener(this); 

	deOne = new DateEntry(p.getDay(0),p.getMonth(0),p.getYear(0));
	deOne.setAlignmentX(0);
	in.add(deOne);

	deTwo = new DateEntry(p.getDay(1),p.getMonth(1),p.getYear(1));
	deTwo.setAlignmentX(0);

	combo.setSelectedIndex( p.getFormat() );

	// Done
	deOne.requestFocus();
		
  }      }