package genj.edit;



import javax.swing.*;
import javax.swing.event.*;

import java.awt.*;
import java.awt.event.*;

import genj.gedcom.*;/** 
 * Proxy for a Entity's Property
 */
class ProxyEntity extends Proxy implements ActionListener, DocumentListener {

  private JTextField tfield;
  private JButton bchange;
  private EditView edit;

  /**
   * When button is pressed
   */
  public void actionPerformed(ActionEvent e) {

	// Warn about this action's side-effects
	int rc = JOptionPane.showConfirmDialog(
	  edit.frame,
	  EditView.resources.getString("proxy.change_id?"),
	  EditView.resources.getString("warning"),
	  JOptionPane.YES_NO_OPTION,
	  JOptionPane.WARNING_MESSAGE
	);
	  
	if (rc==JOptionPane.NO_OPTION)
	  return;
	
	// Calc parms
	Gedcom gedcom = prop.getGedcom();
	Entity entity = prop.getEntity();

	// Can I write ?
	if (!gedcom.startTransaction()) {
		return;
	}
	
	// Do the change
	try {

	  // .. id
	  gedcom.setIdOf(entity,tfield.getText());

	  // .. button off
	  bchange.setEnabled(false);
	  
	} catch (GedcomException ex) {

	  // .. error
	  JOptionPane.showMessageDialog(
		edit.frame,
		ex.getMessage(),
		EditView.resources.getString("error"),
		JOptionPane.ERROR_MESSAGE
	  );
	  
	} finally {
	  gedcom.endTransaction();
	}

	// Done
  }        
  /**
	Trigger for Document changes
  */
  public void changedUpdate(DocumentEvent e) {
	bchange.setEnabled(true);
  }      
  /**
   * Finish editing a property through proxy
   */
  protected void finish() {
  }      
  /**
   * Returns change state of proxy
   */
  protected boolean hasChanged() {
	return false;
  }      
  /**
	Trigger for Document changes
  */
  public void insertUpdate(DocumentEvent e) {
	bchange.setEnabled(true);
  }      
  /**
	Trigger for Document changes
  */
  public void removeUpdate(DocumentEvent e) {
	bchange.setEnabled(true);
  }      
  
  /**
   * Start editing a property through proxy
   */
  protected void start(JPanel in, JLabel setLabel, Property prop, EditView edit) {

	// Store some data
	this.edit=edit;
	this.prop=prop;

	// Look for entity
	Entity e = (Entity)prop;

	// Label
	JLabel lid = new JLabel(EditView.resources.getString("proxy.id_of_entity"));
	in.add(lid);
	
	// ID ?
	tfield = new JTextField(e.getId(),10);
	tfield.setScrollOffset(0);
	tfield.setName("!VALUE"); 
	tfield.setAlignmentX(0);
	tfield.setToolTipText(EditView.resources.getString("proxy.enter_id_here"));
	tfield.getDocument().addDocumentListener(this);
	in.add(tfield); 
	
	bchange = new JButton(EditView.resources.getString("proxy.change"));
	bchange.addActionListener(this);
	bchange.setActionCommand("CHANGE");
	bchange.setEnabled(false);
	in.add(bchange);
	
	tfield.requestFocus();	 
	
	// Done
  }        }