package genj.edit;

import javax.swing.*;
import javax.swing.filechooser.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Vector;




import genj.gedcom.*;import genj.util.*;/** 
 * Proxy for editing GEDCOM-Property File
 */
class ProxyFile extends Proxy implements ActionListener {

  private EditView     edit;
  private Frame        frame;
  private JLabel       lImage;
  private JScrollPane  sImage;
  private JTextField   tFile;

  /**
   * User pressed button to select file
   */
  public void actionPerformed(ActionEvent e) {

	PropertyFile p = (PropertyFile)prop;
	String newValue=null;
	File   newFile =null;
	  
	// Button or text-field ?
	if (e.getSource()==tFile) {
	  newValue = tFile.getText();
	} else {
	  // Let the user choose a file
	  JFileChooser chooser = new JFileChooser(".");
	  chooser.setDialogTitle("Choose a file");
	
	  int rc=chooser.showDialog(frame, "Choose file");
	  
	  // Cancel ?
	  if (JFileChooser.APPROVE_OPTION != rc)
		return;
	  newFile = chooser.getSelectedFile();

	}
	
	// Can I write ?
	Gedcom gedcom = prop.getGedcom();

	if (!gedcom.startTransaction()) {
		return;
	}
	
	// Change File-link
	if (newFile!=null)
	  p.setValue(newFile);
	else
	  p.setValue(newValue);

	// Done
	gedcom.endTransaction();
	
	// Let it show
	showFile();

  }      
  /**
   * Finish editing a property through proxy
   */
  protected void finish() {
	// Done
  }      
  /**
   * Returns change state of proxy
   */
  protected boolean hasChanged() {
	return false;
  }      
  /**
   * Shows property's image if possible
   */
  private void showFile() {
	
	PropertyFile pFile = (PropertyFile)prop;
	tFile.setText( pFile.getValue() );
	
	// Image from File?
	ImgIcon i = pFile.getValueAsIcon();
	ImageIcon icon = (i==null ? null : i.getImageIcon());
	if ( (icon==null)||(icon.getIconWidth()<1)||(icon.getIconHeight()<1) ) {
	  lImage.setText("No image file");
	  lImage.setIcon(null);
	} else {
	  lImage.setIcon(icon);
	  lImage.setText("");
	}

	// Update visually
	lImage.invalidate();
	sImage.validate();
  }      
  
  /**
   * Start editing a property through proxy
   */
  protected void start(JPanel in, JLabel setLabel, Property setProp, EditView setEdit) {

	edit =setEdit   ;
	prop =setProp   ;
	frame=edit.frame;

	// Add a button for FileChooserAction
	JPanel p = new JPanel();
	p.setLayout(new BoxLayout(p,BoxLayout.X_AXIS));
	p.setAlignmentX(0);
	
	tFile = new JTextField(14);
	tFile.setAlignmentY(0.5F);
	tFile.addActionListener(this);
	p.add(tFile);
	
	JButton bFile = new JButton("Choose File");
	bFile.addActionListener(this);
	bFile.setAlignmentY(0.5F);
	p.add(bFile);

	in.add(p);
	
	// Any graphical information that could be shown ?
	lImage = new JLabel();
	lImage.setHorizontalAlignment(SwingConstants.CENTER);
	sImage = new JScrollPane(lImage);
	sImage.setMinimumSize(new Dimension(0,0));
	in.add(sImage);

	showFile();

	// Done
  }      }