package genj.edit;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.Vector;


import genj.gedcom.*;/** 
 * Proxy for editing GEDCOM-Property Name
 */
class ProxyName extends Proxy implements DocumentListener {

  private JTextField tlast,tfirst;
  private boolean changed=false;

  /**
	Trigger for Document changes
  */
  public void changedUpdate(DocumentEvent e) {
	changed = true;
  }      
  /**
	Finish editing a property through proxy
  */
  protected void finish() {
	
	// Has something been edited ?
	if ( !hasChanged() )
	  return;

	// ... calc texts
	String first = tfirst.getText().trim(),
		   last  = tlast .getText().trim();

	// ... store changed value
	PropertyName p = (PropertyName) prop;
	p.setName( first , last );
		
	// Done
  }      
  /**
   * Returns change state of proxy
   */
  protected boolean hasChanged() {
	return changed;
  }      
  /**
	Trigger for Document changes
  */
  public void insertUpdate(DocumentEvent e) {
	changed = true;
  }      
  /**
	Trigger for Document changes
  */
  public void removeUpdate(DocumentEvent e) {
	changed = true;
  }      
  
  /**
   * Start editing a property through proxy
   */
  protected void start(JPanel in, JLabel setLabel, Property setProp, EditView edit) {

	prop=setProp;
	PropertyName pname = (PropertyName)prop;

	// Unknown property can be changed through a TextField
	tlast  = new JTextField ( pname.getLastName()   );
	tfirst = new JTextField ( pname.getFirstName()  );
	
	tlast.setAlignmentX(0);
	tfirst.setAlignmentX(0);

	tlast .setName("B");
	tfirst.setName("FB");
	tlast .getDocument().addDocumentListener(this); 
	tfirst.getDocument().addDocumentListener(this); 
	
	JLabel l = new JLabel( pname.getLabelForFirstName() );
	l.setAlignmentX(0);
	l.setName("B");
	in.add(l);
	in.add(tfirst);
	l = new JLabel( pname.getLabelForLastName() );
	l.setAlignmentX(0);
	l.setName("B");
	in.add(l);
	in.add(tlast);
	in.add(Box.createVerticalGlue());

	tfirst.requestFocus();

	// Done
  }      }