package genj.edit;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.Vector;




import genj.gedcom.*;import genj.util.*;/** 
 * Proxy for editing GEDCOM-Property Sex
 */
class ProxySex extends Proxy implements ItemListener {

  private JLabel label;
  private JRadioButton rbMale,rbFemale;
  private boolean changed=false;

  /**
   * Finish editing a property through proxy
   */
  protected void finish() {
	// Something changed ?
	if (! hasChanged() )
	  return;
	// Gather data change
	try {
	  if ( rbMale.getModel().isSelected() == true)
		((PropertySex)prop).setSex(Gedcom.MALE);
	  else		
		((PropertySex)prop).setSex(Gedcom.FEMALE);
	  } catch (IllegalArgumentException ex) {
		System.out.println(ex);
	  }	
	// Done
  }      
  /**
   * Returns change state of proxy
   */
   protected boolean hasChanged() {
	 return changed;
   }         
  /**
   * RadioButton has been selected
   */
  public void itemStateChanged(ItemEvent e) {

	// We're waiting for selection only
	if (e.getStateChange() != e.SELECTED)
	  return;

	changed=true;
	
	// Gather data change
	ImgIcon img;
	if ( rbMale.getModel().isSelected() == true)
	  img=((PropertySex)prop).getDefaultImage(Gedcom.MALE);
	else
	  img=((PropertySex)prop).getDefaultImage(Gedcom.FEMALE);
	
	// Image change
	label.setIcon(new ImageIcon(img.getImage()));
	
	// Done
  }      
  
  /**
   * Start editing a property through proxy
   */
  protected void start(JPanel in, JLabel setLabel, Property setProp, EditView edit) {

	label=setLabel;
	prop=setProp;
	PropertySex p = (PropertySex) prop;

	rbMale   = new JRadioButton( p.getLabelForSex(Gedcom.MALE)   );
	rbFemale = new JRadioButton( p.getLabelForSex(Gedcom.FEMALE) );

	rbMale.setBorder(BorderFactory.createEmptyBorder(4,4,4,4));
	rbFemale.setBorder(BorderFactory.createEmptyBorder(4,4,4,4));
		
	in.add(rbMale); 
	in.add(rbFemale); 

	ButtonGroup bg = new ButtonGroup(); 
	rbMale  .getModel().setGroup(bg);
	rbFemale.getModel().setGroup(bg);
	
	if (p.getSex() == Gedcom.MALE) {
	  rbMale  .getModel().setSelected(true);
	  rbFemale.requestFocus();
	} else {
	  rbFemale.getModel().setSelected(true);
	  rbMale  .requestFocus();
	}	
	
	rbMale.getModel().addItemListener(this);
	rbFemale.getModel().addItemListener(this);
	
	
	// Done
  }      }