package genj.edit;

 

import javax.swing.*;
import javax.swing.event.*;
import java.util.Vector;

import genj.gedcom.Property;/** 
 * Proxy for editing GEDCOM-Property Unknown
 */
class ProxyUnknown extends Proxy implements DocumentListener {

  private boolean changed;
  private JTextField tfield;

  public void changedUpdate(DocumentEvent e) {
	changed = true;
  }      
  /**
   * Finish editing a property through proxy
   */
  protected void finish() {

	// Has something been edited ?
	if ( !hasChanged() )
	  return;
	  
	// Store changed value
	prop.setValue(tfield.getText());

	// Done
	return;
  }      
  /**
   * Returns change state of proxy
   */
   protected boolean hasChanged() {
	 return changed;
   }         
  public void insertUpdate(DocumentEvent e) {
	changed = true;
  }      
  public void removeUpdate(DocumentEvent e) {
	changed = true;
  }      
  
  /**
   * Start editing a property through proxy
   */
  protected void start(JPanel in, JLabel setLabel, Property setProp, EditView edit) {
	
	prop=setProp;

	// Setup controls
	tfield = new JTextField(prop.getValue(),10);
	tfield.setScrollOffset(0);
	tfield.setName("!VALUE");
	tfield.getDocument().addDocumentListener(this); 
	tfield.setAlignmentX(0);
	in.add(tfield);
	tfield.requestFocus();	
	// Done
  }      }