package genj.edit;




import java.awt.*; 
import java.awt.event.*;
import java.util.Vector;
import java.util.StringTokenizer; 

import javax.swing.*;
import javax.swing.event.*;

import genj.gedcom.*;import genj.util.*;/** 
 * Proxy for editing XRef GEDCOM-Property : Child,Husband,Wife,FamilyChild,FamilySpouse
 */
class ProxyXRef extends Proxy implements ActionListener  {

  EditView edit;
  private JTextField tfield;

  /**
   * When button is pressed
   */
  public void actionPerformed(ActionEvent e) {
	  
	// Jump to linked entity ?
	if ("JUMP".equals(e.getActionCommand())) {
	  jump();
	  return;
	}
	// Link entered entity-id ?
	if ("LINK".equals(e.getActionCommand())) {

	  // .. try to write
	  Gedcom gedcom = prop.getGedcom();
	  
	  if (!gedcom.startTransaction())
	  	return;
	  	
	  // Try to link
	  String id = "@"+tfield.getText()+"@";
	  prop.setValue(id);
	  try {
		((PropertyXRef)prop).link();
		edit.setEntity(prop.getEntity());
	  } catch (GedcomException ex) {
		JOptionPane.showMessageDialog(
		  edit.frame,
		  ex.getMessage(),
		  EditView.resources.getString("error"),
		  JOptionPane.ERROR_MESSAGE
		);
	  }

	  // Unlock
	  gedcom.endTransaction();

	  // Done
	  return;
	}
	// Unknown
	return;
  }        
  /**
   * Finish editing a property through proxy
   */
  protected void finish() {

	// Has something been edited ?
	if ( !hasChanged() )
	  return;
	// Store changed value
	prop.setValue(tfield.getText());

	// Done
  }      
  /**
   * Returns change state of proxy
   */
  protected boolean hasChanged() {

	// Already Linked?
	if (tfield==null)
	  return false;

	String id = ((PropertyXRef)prop).getReferencedId();
	return !tfield.getText().equals(id);
  }      
  /**
   * Jump to referenced entity
   */
  public void jump() {

	Entity e = ((PropertyXRef)prop).getReferencedEntity();
	if (e==null)
	  return;
	edit.setEntity( e );
  }      
  
  /**
   * Start editing a property through proxy
   */
  protected void start(JPanel in, JLabel setLabel, Property setProp, EditView edit) {
	
	// Remember property & edit
	prop=setProp;
	this.edit=edit;

	// Calculate reference information
	PropertyXRef pxref = (PropertyXRef) prop;

	// Valid link ? 
	if (pxref.getReferencedEntity()!=null) {
	  JButton b = new JButton(EditView.resources.getString("proxy.jump_to",pxref.getReferencedEntity().getId()));
	  b.setIcon(new ImageIcon(pxref.getReferencedEntity().getProperty().getImage(true).getImage()));
	  b.setActionCommand("JUMP");
	  b.addActionListener(this);
	  in.add(b);
	  return;
	}

	// Not valid link ?
	tfield = new JTextField(pxref.getReferencedId(),10);
	tfield.setScrollOffset(0);
	tfield.setName("!VALUE"); 
	tfield.setAlignmentX(0);
	tfield.setToolTipText(EditView.resources.getString("proxy.enter_id_here"));
	in.add(tfield); 
	
	JButton b = new JButton(EditView.resources.getString("proxy.link"));
	b.setIcon(new ImageIcon(new ImgIcon(this,"Link.gif").getImage()));
	b.addActionListener(this);
	b.setActionCommand("LINK");
	in.add(b);
	
	tfield.requestFocus();	 
		
	// Done
  }        }