package genj.gedcom;

/**
 * Interface for generic Entity in a genealogic file.
 */
public interface Entity {

  /**
   * Notification to entity that it has been added to a Gedcom
   */
  public void addNotify(Gedcom gedcom);      
  /**
   * Notification to entity that it has been deleted from a Gedcom
   */
  public void delNotify();      
  /**
   * Gedcom this entity's in
   * @return containing Gedcom
   */
  public Gedcom getGedcom();      
  /**
   * Returns entity's id
   * @return id
   */
  public String getId();      
  /**
   * Entity's main property
   * @return Property
   */
  public Property getProperty();      
  /**
   * Returns the type to which this entity belongs
   * INDIVIDUALS, FAMILIES, MULTIMEDIAS, NOTES, ...
   */
  public int getType();      
  /**
   * Set Gedcom this entity's in
   */
  public void setGedcom(Gedcom gedcom);      
  /**
   * Sets entity's id
   */
  public void setId(String setId);      
}