package genj.gedcom;

/**
  Interface for Listeners of changes in gedcom data
*/
public interface GedcomListener {

  /**
   * Notification that a change in a Gedcom-object took place.
   * @param Change describing the change
  */
  public void handleChange(Change change);      
  /**
   * Notification that this gedcom is beeing closed
   */
  public void handleClose(Gedcom which);      
  /**
   * Notification that an entity has been selected.
   */
  public void handleSelection(Selection selection);      
}