package genj.gedcom;

import java.awt.Image; 
import java.util.Vector; 


import genj.util.*;/**
  Gedcom property which constitutes an Age
*/
public class PropertyAge extends Property {

  int age;
  String ageAsString;

/**
 * Constructor
 */
public PropertyAge(int setAge) {
	age=setAge;
	ageAsString=null;
}  
  /**
   * Constructor
   */
  public PropertyAge(String tag, String value) {
	setValue(value);
  }      
  public static ImgIcon getDefaultImage() {
	return Images.imgTime;
  }      
  public ImgIcon getImage(boolean checkValid) {
	if ((checkValid)&&(ageAsString!=null))
	  return Images.imgError;
	return Images.imgTime;
  }      
  public String getTag() {
	return "AGE";
  }      
  public String getValue() {
	if (ageAsString!=null)
	  return ageAsString;
	return String.valueOf(age);
  }      
  public boolean setValue(String newValue) {
	// Transformation to int
	Integer i;
	try {
	  i = Integer.valueOf(newValue);
	} catch (NumberFormatException e) {
	  noteModifiedProperty();
	  ageAsString=newValue;
	  age=0;
	  return false;
	}	
	// OK
	noteModifiedProperty();
	ageAsString=null;
	age = i.intValue();
	// Done
	return true;
  }      
}