package genj.gedcom;

import java.util.*;

/**
 * Wrapper for a Property (could be read from XML file later)
 */
public class PropertyDefinition {

	// Members
	private String    theTag;
	private Class     theClass;
	private Vector    vSubTags;
	private Hashtable hSubTags;

public PropertyDefinition(String t, String c) {
	this(t,c,new String[0]);
}
public PropertyDefinition(String t, String c, String[] s) {

	// Remember data
	theTag = t;
	
	// Figure out the class
	try {
		theClass = Class.forName(Property.class.getName()+c);
	} catch (Throwable throwable) {
		// changed to throwable for IE throwing a security exception for unknown type :(
		theClass = new PropertyUnknown("","").getClass();
	}
	// Initialize subTags
	vSubTags = new Vector(s.length+4);
	hSubTags = new Hashtable(s.length+4);
	for (int i=0;i<s.length;i++) {
		vSubTags.addElement(s[i]);
		hSubTags.put(s[i],s[i]);
	}
	isEvent = PropertyEvent.class.isAssignableFrom(theClass);
}
public void addSubTag(String tag) {
	if (hSubTags.contains(tag))
		return;
	vSubTags.addElement(tag);
	hSubTags.put(tag,tag);
}
public Class getPropertyClass() {
	return theClass;
}
public Vector getSubTags() {
	return vSubTags;
}
public String getTag() {
	return theTag;
}
	private boolean   isEvent;/**
 * Returns whether this definition represents an event or not
 */
public boolean isEvent() {
	return isEvent;
}}