package genj.gedcom;

import java.util.Vector; 

 
import genj.util.*;/*
 * Gedcom property for miscellaneous types
 */
public class PropertyGenericAttribute extends Property {

  private String tag;
  private String value;

  /**
   * Constructor of address Gedcom-line
   */
  public PropertyGenericAttribute(String initTag) {
	
	// Remember
	tag = initTag;
		
	// Done
  }      
  /**
   * Constructor of address Gedcom-line
   */
  public PropertyGenericAttribute(String tag, String value) {
	
	// Remember
	this.tag = tag;
	setValue(value);
	// Done
  }      
  /**
   * Returns the default image of this property
   */
  public static ImgIcon getDefaultImage() {
	return Images.imgAttribute;
  }      
  /**
   * Returns the image of this property
   */
  public ImgIcon getImage(boolean checkValid) {

	if (tag.equals("TYPE")) return Images.imgType;
	if (tag.equals("FORM")) return Images.imgFormat;
 
	// Return Default
	return Images.imgAttribute;
  }      
  /**
   * Returns the tag of this property
   */
  public String getTag() {
	return tag;
  }      
  /**
   * Returns the value of this property
   */
  public String getValue() {
	return value;
  }      
  /**
   * Sets the value of this property
   */
  public boolean setValue(String value) {
	noteModifiedProperty();
	this.value=value;
	return true;
  }      
}