package genj.gedcom;

import java.util.Date;


import genj.util.*;/**
 * Class for encapsulating a person as property
 */
public abstract class PropertyIndi extends Property{
  /**
   * Adds all default properties to this property
   */
  public void addDefaultProperties() {
	addProperty(new PropertyName());
	addProperty(new PropertySex(Gedcom.MALE));
	addProperty(new PropertyEvent("BIRT"));
	addProperty(new PropertyEvent("DEAT"));
  }        
/**
 * Compares this property to another property
 * @return -1 this < property <BR>
 *          0 this = property <BR>
 *          1 this > property
 */
public int compareTo(Property p) {
	try {
		return 
			Integer.parseInt(getEntity().getId().substring(1))
			-
			Integer.parseInt(p.getEntity().getId().substring(1));
	} catch (Exception e) {
	}
	return getEntity().getId().compareTo(p.getEntity().getId());
}      
  public static ImgIcon getDefaultImage() {
	return Images.imgIndi;
  }      
  public ImgIcon getImage(boolean checkValid) {
	return getDefaultImage();
  }      
  /**
   * Returns the logical name of the proxy-object which knows this object
   */
  public String getProxy() { 
	return "Entity";
  }      
  /**
   * Returns the name of the proxy-object which knows properties looked
   * up by TagPath
   * @return proxy's logical name
   */
  public static String getProxy(TagPath path) {
	return "Entity"; 
  }      
  public String getTag() { 
	return "INDI";
  }      
  public String getValue() {
	return "";
  }      
  public boolean setValue(String value) {
	return false;
  }      
}