package genj.gedcom;

import java.util.Vector; 


import genj.util.*;/*
 * Gedcom property which constitutes a generic attribute for
 * an individual which itself provides sub-properties AGNC, DATE, PLACE and TYPE
 */
public class PropertyIndividualAttribute extends Property {

	private String tag;
	private String value;

  /**
   * Constructor of address Gedcom-line
   */
  public PropertyIndividualAttribute(String initTag) {
	
	// Remember
	tag = initTag;
		
	// Done
  }      
  /**
   * Constructor of address Gedcom-line
   */
  public PropertyIndividualAttribute(String tag, String value) {
	
	// Remember
	this.tag = tag;
	setValue(value);
	// Done
  }      
  /**
   * Adds all default properties to this property 
   */
  public void addDefaultProperties() {

	// RESIdence ?
	if (getTag().equals("RESI")) {
	  addProperty(new PropertyAddress());
	  addProperty(new PropertyDate());
	  return;
	}

	// Done
  }        
  public static ImgIcon getDefaultImage() {
	return Images.imgAttribute;
  }      
  public ImgIcon getImage(boolean checkValid) {
	// Known property ?
	if (tag.equals("OCCU"))
	  return Images.imgOccu;
	if (tag.equals("NATI"))
	  return Images.imgNati;
	// Return Default
	return getDefaultImage();
  }          
  public String getTag() {
	return tag;
  }      
  public String getValue() {
	return value;
  }      
  public boolean setValue(String value) {
	noteModifiedProperty();
	this.value=value;
	return true;
  }      
}