package genj.gedcom;

import java.util.*;

/**
 * Class for encapsulating a set of Properties
 */
public class PropertyList {

	private Vector vector = new Vector();

/**
 * Adds another property to this set of properties
 * @prop the property to add to this list
 * @parent the parent of this list
 */
PropertyList add(Property prop, Property parent) {
	vector.addElement(prop);
	prop.addNotify(parent);
	return this;
}
/**
 * Property in list?
 */
public boolean contains(Property property) {
	return vector.contains(property);
}
/**
 * Removes a property
 */
PropertyList delete(Property which) {
	vector.removeElement(which);
	which.delNotify();
	return this;
}
/**
 * Removes all property
 */
PropertyList deleteAll() {

	Enumeration e = ((Vector)vector.clone()).elements();

	vector.removeAllElements();
	
	while (e.hasMoreElements())
		((Property)e.nextElement()).delNotify();

	return this;
}
  /**
   * Returns one of the properties in this set by index
   */
  public Property get(int which) {
	return ((Property)vector.elementAt(which));
  }      
  /**
   * Returns one of the properties in this set by tag
   */
  public Property get(String tag) {

	Property p;
	for (int i=0;i<getSize();i++) {
	  p = get(i);
	  if (p.getTag().equals(tag)) return p;
	}
	return null;
  }      
  /**
   * Returns the number of properties in this set
   */
  public int getSize() {
	return vector.size();
  }      
  /**
   * Swaps place of properties given by index
   */
  public void swap(int i, int j) {

	Object o = vector.elementAt(i);
	vector.setElementAt(vector.elementAt(j),i);
	vector.setElementAt(o,j);
  }      
}