package genj.gedcom;

/**
 * Class that encapsulated selection
 */
public class Selection {

  Entity entity;
  GedcomListener listener;
  boolean doubleClick;
  
  /**
   * Constructor
   */
  Selection(Entity entity, GedcomListener listener, boolean doubleClick) {
	this.entity     =entity     ;
	this.listener   =listener   ;
	this.doubleClick=doubleClick;
  }      
  /**
   * Returns selected entity
   */
  public Entity getEntity() {
	return entity;
  }      
  /**
   * Returns listener who caused event
   */
  public GedcomListener getListener() {
	return listener;
  }      
  /**
   * Returns wether it was selected by double-click
   */
  public boolean isDoubleClick() {
	return doubleClick;
  }      
}