package genj.io;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import javax.swing.*;
import java.io.File;


/**
 * Class that asks for GEDCOM to be opened from user
 */
public class GedcomChooser extends JFileChooser {

  private String command;
  private JFrame frame;
  
  /*
   * Filter files
   */
  class GedcomFilter extends FileFilter {

	String ged[] = { "ged" };

	/**
	 * Files to accept
	 */
	public boolean accept(File f) {

	  if (f.isDirectory())
		return true;

	  String s= f.getName();
	  int i =s.lastIndexOf('.');
	  if (i>0) {

		for (int e=0;e<ged.length;e++) {
		  if (ged[e].equals( s.substring(i+1).toLowerCase() ))
			return true;
		}

	  }
	  return false;
	}

	/**
	 * Description
	 */
	public String getDescription() {
	  return "GEDCOM (*.ged)";
	}
	
  }
  /**
   * Constructor
   */
  public GedcomChooser(JFrame frame, String title, String command) {
	super(".");
	this.frame=frame;
	this.command=command;
	GedcomFilter filter=new GedcomFilter();
	addChoosableFileFilter(filter);
	setFileFilter(filter);
	setDialogTitle(title);
  }      
  /**
   * show it
   */
  public int showDialog() {
	return showDialog(frame,command);
  }      
}