package genj.io;

/**
 * Interface that defines how to track progressing operation
 */
public interface Trackable {

  /**
   * Cancels operation
   */
  public void cancel();      
  /**
   * Returns progress of operation in % (0-100)
   */
  public int getProgress();      
  /**
   * Returns state as explanatory string
   */
  public String getState();      
  /**
   * Returns warnings of operation
   */
  public String getWarnings();      
}