package genj.option;

import java.awt.*; 
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;



 

import genj.gedcom.*;import genj.util.*;/**
 * Class that defines mask for creation of a new individual
 */
class MaskForNewFam extends MaskForNewEntity implements ItemListener {
	
  private Entity entity   = null;
  private boolean intern=false;

  JLabel       lMarrDate,lMarrPlace,lNote;
  DateEntry    dMarrDate;
  JTextField   tMarrPlace;

  JLabel       lMemberIs;
  JCheckBox    cbMemberIs;
  JRadioButton rbParent  ,
			   rbChild   ;               

  /**
   * Constructor for new family mask
   */
  public MaskForNewFam() {
	
	// Family Data
	lMarrDate  = new JLabel(OptionResources.getString("mask.fam.marr_date"));
	lMarrPlace = new JLabel(OptionResources.getString("mask.fam.marr_place"));

	tMarrPlace = new JTextField("");
	dMarrDate  = new DateEntry(null,null,null);
	
	// Relation
	cbMemberIs  = new JCheckBox(OptionResources.getString("mask.fam.member_is"),false);
	cbMemberIs .setEnabled(false);
	lMemberIs   = new JLabel(OptionResources.getString("mask.none"));
	lMemberIs  .setBackground(new Color(255,255,239));	  
	cbMemberIs.addItemListener(this); 

	rbParent  = new JRadioButton(OptionResources.getString("mask.fam.parent"),true );
	rbChild   = new JRadioButton(OptionResources.getString("mask.fam.child" ),false);
	
	rbParent .setToolTipText(OptionResources.getString("mask.fam.parent.tip"));
	rbChild  .setToolTipText(OptionResources.getString("mask.fam.child.tip"));

	ButtonGroup g2 = new ButtonGroup();	           
	g2.add(rbParent);
	g2.add(rbChild);
	
	// Init
	handleContextChange(null);
	
	// Done
  }        
  /**
   * Initiates entity's creation
   */
  boolean createIn(Gedcom gedcom) {

	// Talking about the same Gedcom ?
	if ((entity!=null)&&(entity.getGedcom()!=gedcom))
	  return false;

	// Create it
	int memberIs = Gedcom.REL_NONE;
	
	if (cbMemberIs.isSelected() == true) {
	  
	  if (rbParent .isSelected() && rbParent.isEnabled() )
		memberIs = Gedcom.REL_PARENT;
	  if (rbChild  .isSelected() && rbChild .isEnabled() )
		memberIs = Gedcom.REL_CHILD;
	  
	}	

	PropertyDate p = new PropertyDate();
	p.setValue(1,dMarrDate.getDay(),dMarrDate.getMonth(),dMarrDate.getYear());

	Fam fam;
	try {
	  fam = gedcom.createFam(memberIs,entity);
	} catch (GedcomException e) {
	  System.out.println(e);
	  return false;
	}
	fam.addMarriage(p.toString(),tMarrPlace.getText());

	// Done
	return true;
  }      
  /**
   * Returns the data-page for entity
   */
  JPanel getDataPage() {
	
	// Prepare panel
	JPanel result = new JPanel();
	
	GridBagHelper helper = new GridBagHelper(result);
	
	helper.add(lMarrDate ,1,1,1,1);
	helper.add(dMarrDate ,2,1,1,1,helper.GROW_HORIZONTAL);
	helper.add(lMarrPlace,1,2,1,1);
	helper.add(tMarrPlace,2,2,1,1,helper.GROW_HORIZONTAL);
	
	// Done
	return result;
  }      
  /**
   * Returns the data-page for entity
   */
  JPanel getRelationPage(JComponent firstRow) {

	// Prepare panel
	JPanel result = new JPanel();
	
	GridBagHelper helper = new GridBagHelper(result);

	helper.add(firstRow  ,0,0,3,1);
	helper.add(cbMemberIs,0,1,2,1);
	helper.add(lMemberIs ,2,1,1,1);
	helper.add(Box.createHorizontalStrut(6) ,0,2,1,1);
	helper.add(rbParent  ,1,2,1,1);
	helper.add(rbChild   ,2,2,1,1);
	
	// Done
	return result;
  }      
  /**
	One of the checkboxes has been selected
  */
  public void itemStateChanged(ItemEvent e) {

	// Not always a reaction
	if (intern)
	  return;

	// No relationship any more / again
	if (!cbMemberIs.isSelected()) {

	  rbParent  .setEnabled(false); 
	  rbChild   .setEnabled(false);
	  
	}
	
	// Done		
  }        
  
/**
 * Sets mask's entity
 */
void handleContextChange(Gedcom gedcom) {

	// Check out if we can find an entity to relate to
	Entity newEntity = null;
	
	if (gedcom!=null) {

		// .. the last one?
		newEntity = gedcom.getLastEntity();
		if (!(newEntity instanceof Indi)) {

			// .. the first Indi?
			try { newEntity = gedcom.getIndi(0); } catch (Exception e) {}
			
		}
	}
	
	// No more?
	if (newEntity==null) {
		
	  this.entity=null;
	  
	  rbParent  .setEnabled(false); 
	  rbChild   .setEnabled(false); 
	  intern = true;
	  cbMemberIs.setSelected(false);
	  cbMemberIs.setEnabled (false);
	  intern = false;

	  lMemberIs.setText( OptionResources.getString("mask.none") );
	  lMemberIs.setIcon( null );

	  return;
	}

	// Remember the entity
	entity = newEntity;
	
	// Individual !
	Indi indi = (Indi)entity;
	  
	lMemberIs.setText( "@"+indi.getId()+"@" );
	lMemberIs.setIcon( new ImageIcon(PropertyIndi.getDefaultImage().getImage()) );
 
	rbParent .setEnabled(true);
	rbChild  .setEnabled(indi.getFamc() == null);
 
	intern = true;
	cbMemberIs.setEnabled(true); 
	cbMemberIs.setSelected(true);
	intern = false;
	
	// Done
  }          }