package genj.print;

import java.awt.*;
import javax.swing.*;

/**
 * Interface between Printer and Renderer
 */
public interface PrintRenderer {

  /**
   * Returns a panel for editing this renderers properties
   */
  public JPanel getEditor();      
  /**
   * Returns size of rendering object in pixels
   */
  public Dimension getSize();      
  /**
   * Renders print data for page
   * @param g Graphics to render on
   */
  public void renderPage(Graphics g, Dimension dimPages);      
  /**
   * Renders a preview
   * @param g Graphics to render on
   * @param zoom zoom rate to use
   */
  public void renderPreview(Graphics g, Dimension dimPreview, float zoomPreview);      
  /**
   * Tells the renderer which printer it is used by
   */
  public void setPrinter(Printer printer);      
}