package genj.timeline;



import genj.gedcom.*;/**
 * Class which links to an event of a family and its point in time
 */
class LinkOfFam extends Link {

  /**
   * Constructor
   */
  LinkOfFam(PropertyEvent pevent, float minYear, float maxYear) {
	super(pevent,minYear,maxYear);
  }      
  /**
   * Entity dependent text for link description
   */
  String getText() {
	
	Fam fam = (Fam)pevent.getEntity();
	Indi husband,wife;

	String name;
	
	husband = fam.getHusband();
	wife = fam.getWife();

	while (true) {

	  // Husband and Wife ?
	  if ((husband!=null)&&(wife!=null)) {
		name = husband.getName() + " and " + wife.getName();
		break;
	  }

	  // Husband ?
	  if (husband!=null) {
		name = husband.getName();
		break;
	  }

	  // Wife ?
	  if (wife!=null) {
		name = wife.getName();
		break;
	  }
		
	  // None !
	  name = "@"+fam.getId()+"@";

	}

	return name;
  }      
}