package genj.tool;





import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import javax.swing.*;

import genj.gedcom.*;import genj.util.*;import genj.app.*;/**
 * Transaction Panel - Select a Gedcom candidate
 */
public class SelectGedcomPanel extends JPanel {

	private Transaction           transaction;
	private JComboBox             chooser;
  
	private final static String[] header = {
		"Please select a Gedcom file:"
	};

/**
 * Konstruktor
 * @param transaction the Transaction this Panel is used in
 */
public SelectGedcomPanel(String explanation, Vector gedcoms) {

	// Prepare components
	GridBagHelper helper = new GridBagHelper(this);

	// .. heading description
	int row=0;
	for (int i=0;i<header.length;i++,row++)
	  helper.add(new JLabel(header[i]),0,row,1,1,helper.GROW_HORIZONTAL);

	// .. candidate
	chooser = new JComboBox(gedcoms);
	helper.add(chooser,0,row++,1,1,helper.GROW_HORIZONTAL);

	// .. explanation
	JTextPane tExplanation = new JTextPane();
	tExplanation.setEnabled(false);
	tExplanation.setText(explanation);
	JScrollPane sExplanation = new JScrollPane(
	  tExplanation,
	  JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
	  JScrollPane.HORIZONTAL_SCROLLBAR_NEVER
	);
	sExplanation.setPreferredSize(new Dimension(64,64));

	helper.add(sExplanation,0,row++,1,1,helper.GROW_BOTH);

	// Done
  }      
/**
 * Bound property support
 */
public void addActionListener(ActionListener listener) {
	chooser.addActionListener(listener);
}
  /**
   * Returns the selected Gedcom
   */
  public Gedcom getGedcom() {
	return (Gedcom)chooser.getSelectedItem();
  }      
  /**
   * Bound property support
   */
  public void removeActionListener(ActionListener listener) {
	chooser.removeActionListener(listener);
  }      
  /**
   * Sets the selected Gedcom
   */
  public void setCandidate(Gedcom which) {
	  chooser.setSelectedItem(which);
  }      
}