package genj.tree;

import java.awt.*; 

 


import genj.util.*;import genj.gedcom.Entity;/**
 * Class for a visible Plus/Minus in a tree
 */
class PlusMinus extends Link {

  boolean stopped;
  
  final static Dimension dim = new Dimension(Images.imgPlus.getIconWidth(),Images.imgPlus.getIconWidth());

  /**
   * Constructor for LinkToPlus
   */
  PlusMinus(TreeModel model, int setDepthInTree,int setPosInGen,Entity setEntity, boolean topAligned) {
	// Inherited
	super(setDepthInTree+(topAligned?6:-6),setPosInGen,setEntity);
	stopped = model.isStopper(setEntity);
	// Done
  }      
  /**
   * Action for click on PlusMinus
   */
  void clickIn(TreeModel model) {
	Entity e = getEntity();
	if (e==null) return;
	stopped = model.flipStopper(getEntity());
  }      
  /**
   * Action for doubleclick on PlusMinus
   */
  void dclickIn(TreeModel model) {
	clickIn(model);
  }      
  /**
   * Returns proxies for this link
   */
  Proxy[] getProxies(TreeGraphics tg) {
	return null;
  }      
  /**
   * Returns the pixel size in tree
   */
  Dimension getSize(TreeModel model) {
	return dim;
  }      
  /**
   * Draws a Plus in a tree
   */
  boolean paint(TreeGraphics g, boolean clearBG, boolean isDetail) {

	// Drawing of folding
	if ((!g.isFolding)||(!isDetail))
	  return false;
	
	// Calc some parms
	Dimension s = getSize(g.getModel());
	
	int pig=getPosInGen()   ,
		dit=getDepthInTree();

	// Check Visibility
	if (!g.isVisible(dit,pig,s))
	  return false;
		  
		
	// Draw Plus-Sign
	ImgIcon img;
	if (getEntity()==null)
	  img=Images.imgMore;
	else
	  img= stopped ? Images.imgPlus : Images.imgMinus;

	g.drawImage(img,dit-dim.height/2,pig-dim.width/2);
	
	// Done		     
	return true;

  }      
}