package genj.tree;








import java.awt.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

import genj.gedcom.*;import awtx.*;import genj.app.*;import genj.util.GridBagHelper;import genj.option.*;/**
 * Class for providing PInfo information to a ViewEditor
 */
public class TreeViewInfo extends JTabbedPane implements ViewInfo {

  private TreeView   tree;

  private int entity = Gedcom.INDIVIDUALS;

  private final static int[] filter = {
	Gedcom.INDIVIDUALS,
	Gedcom.FAMILIES
  };

  private JComboBox comboTypes = new JComboBox();
  private Scala scalaZoom = new Scala();
  private JList listBookmarks = new JList();
  private JCheckBox[] checkPaints = {
	new JCheckBox("Show Shadows"),
	new JCheckBox("Show Property Images"),
	new JCheckBox("Zoom Images"),
	new JCheckBox("Vertical")
  };
  private TagPathTree pathTree = new TagPathTree();
  private OptionLayoutProperties layoutProperties = new OptionLayoutProperties();
  private JButton delBookmark = new JButton("Delete"),
				  addBookmark = new JButton("Add"),
				  upBookmark  = new JButton("Up"),
				  downBookmark= new JButton("Down");
  private JTextField labelBookmark = new JTextField();
  private EntitySelector entityBookmark = new EntitySelector();


  /**
   * Constructor
   */
  public TreeViewInfo() {

	// Create a listener
	ActionListener alistener = new ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		if ("ADD".equals(e.getActionCommand()))
		  addBookmark();
		if ("DEL".equals(e.getActionCommand()))
		  delBookmark();
		if ("UP".equals(e.getActionCommand()))
		  moveBookmark(true);
		if ("DOWN".equals(e.getActionCommand()))
		  moveBookmark(false);
		if ("TYPE".equals(e.getActionCommand()))
		  changeType();
	  }
	};
	addBookmark .addActionListener(alistener);
	delBookmark .addActionListener(alistener);
	upBookmark  .addActionListener(alistener);
	downBookmark.addActionListener(alistener);
	comboTypes  .addActionListener(alistener);
	addBookmark .setActionCommand("ADD");
	delBookmark .setActionCommand("DEL");
	upBookmark  .setActionCommand("UP");
	downBookmark.setActionCommand("DOWN");
	comboTypes  .setActionCommand("TYPE");

	TagPathTreeListener tlistener = new TagPathTreeListener() {
	  public void handleSelection(TagPath p, boolean on) {
		if (tree==null)
		  return;
		if (on)
		  layoutProperties.add(p,null);
		else
		  layoutProperties.remove(p);
	  }
	};
	pathTree.addTagPathTreeListener(tlistener);

	// Create Components
	for (int i=0;i<filter.length;i++)
	  comboTypes.addItem(Gedcom.getNameFor(filter[i],true));
	entityBookmark.setFilter(filter);
	Insets ins = new Insets(0,0,0,0);
	addBookmark.setMargin(ins);
	delBookmark.setMargin(ins);
	upBookmark.setMargin(ins);
	downBookmark.setMargin(ins);

	Border defaultBorder = BorderFactory.createEmptyBorder(8,8,8,8);

	// Properties
	JPanel panel = new JPanel();panel.setBorder(defaultBorder);

	  GridBagHelper helper = new GridBagHelper(panel);
	  int row = 0;

	  helper.add(new JLabel("Properties to show"),0,row++,2,1);
	  helper.addFiller(0,row,new Dimension(16,16));
	  helper.add(comboTypes,1,row++,1,1,helper.GROW_HORIZONTAL|helper.FILL_HORIZONTAL);
	  helper.add(pathTree,1,row++,1,1,helper.GROW_BOTH|helper.FILL_BOTH);
	  helper.add(layoutProperties,1,row++,1,1,helper.GROW_BOTH|helper.FILL_BOTH);

	add("Properties",panel);

	// Options
	panel = new JPanel();panel.setBorder(defaultBorder);

	  helper = new GridBagHelper(panel);
	  row = 0;

	  helper.add(new JLabel("Zoom"),0,row++,2,1);
	  helper.add(scalaZoom,1,row++,1,1,helper.FILL_HORIZONTAL);

	  helper.add(new JLabel("Display"),0,row++,2,1);
	  for (int i=0;i<checkPaints.length;i++)
		helper.add(checkPaints[i],1,row++,1,1);

	add("Options",panel);

	// Bookmarks
	panel = new JPanel();panel.setBorder(defaultBorder);

	  helper = new GridBagHelper(panel);
	  row = 0;

	  helper.add(entityBookmark                ,1,row++,5,1);
	  helper.add(labelBookmark                 ,1,row++,5,1);

	  helper.add(addBookmark                   ,1,row  ,1,1,helper.FILL_NONE);
	  helper.add(delBookmark                   ,2,row  ,1,1,helper.FILL_NONE);
	  helper.add(new JLabel()                  ,3,row  ,1,1,helper.GROW_HORIZONTAL);
	  helper.add(upBookmark                    ,4,row  ,1,1,helper.FILL_NONE);
	  helper.add(downBookmark                  ,5,row++,1,1,helper.FILL_NONE);

	  helper.add(new JScrollPane(listBookmarks),1,row++,5,1,helper.GROW_BOTH|helper.FILL_BOTH);

	add("Bookmarks",panel);
	// Done
  }      
/**
 * Adds a bookmark
 */
private void addBookmark() {

	// Get information
	Entity entity = entityBookmark.getEntity();
	String label  = labelBookmark.getText().trim();

	if ((entity==null)||(label.length()==0))
		return;

	// Add new bookmark
	ListModel old_model = listBookmarks.getModel();
	DefaultListModel new_model = new DefaultListModel();

	for (int i=0;i<old_model.getSize();i++)
		new_model.addElement(old_model.getElementAt(i));

	new_model.addElement(new Bookmark(entity,label));

	listBookmarks.setModel(new_model);

	// Done
}
  /**
   * Tells the ViewInfo to apply made changes
   */
  public void apply() {
	writeToTree();
  }      
  /**
   * Changes the type to the current ComboBox selection
   */
  private void changeType() {
	int i = comboTypes.getSelectedIndex();
	if (i==-1)
	  return;
	entity = filter[i];
	readFromTree();
  }      
  /**
   * Removes a bookmark
   */
  private void delBookmark() {

	// Get information
	int i = listBookmarks.getSelectedIndex();
	if (i<0)
	  return;

	// Remove bookmark
	DefaultListModel model = (DefaultListModel)listBookmarks.getModel();
	model.removeElementAt(i);

	// Done
  }      
  /**
   * Has to return the component used fir editing
   */
  public Component getEditor() {
	return this;
  }      
  /**
   * Moves a bookmark up/down
   */
  private void moveBookmark(boolean up) {
	
	int i = listBookmarks.getSelectedIndex();
	int j = up ? i-1 : i+1;
	
	ListModel model = listBookmarks.getModel();
	Bookmark[] bms = new Bookmark[model.getSize()];
	
	if ( (i<0) || (j<0) || (j>=bms.length) )
	  return;
	
	for (int b=0;b<bms.length;b++)
	  bms[b] = (Bookmark)model.getElementAt(b);
	
	
	Bookmark bm = bms[i];
	bms[i] = bms[j];
	bms[j] = bm;
	
	listBookmarks.setListData(bms);
	listBookmarks.setSelectedIndex(j);
	
	//  Done
  }      
  /**
   * Reflect state of Tree in our Editor
   */
  private void readFromTree() {

	// ?
	if (tree==null)
	  return;

	// Clear reference to table for listeners
	TreeView t = tree;
	tree = null;

	// Read options
	checkPaints[0].setSelected(t.isShadow());
	checkPaints[1].setSelected(t.isPropertyImages());
	checkPaints[2].setSelected(t.isZoomBlobs());
	checkPaints[3].setSelected(t.isVertical());

	scalaZoom.setValue(t.getZoom());

	// Read bookmarks
	DefaultListModel model = new DefaultListModel();

	Enumeration bs = t.getBookmarks().elements();
	while (bs.hasMoreElements())
	  model.addElement(bs.nextElement());
	listBookmarks.setModel(model);

	// Reflect properties by TagPaths
	TagPath[] selectedPaths = t.getTagPaths(entity);
	TagPath[] usedPaths     = TagPath.getUsedTagPaths(t.getGedcom(),entity);

	pathTree.setPaths(usedPaths);
	pathTree.setSelection(selectedPaths);

	entityBookmark.setGedcom(t.getGedcom());

	layoutProperties.setFont(t.getFont());
	layoutProperties.setSizeOfEntities(t.getSize(entity));
	layoutProperties.removeAll();
	Proxy[] proxies = t.getProxies(entity);
	for (int i=0;i<proxies.length;i++) {
	  Proxy proxy = proxies[i];
	  layoutProperties.add(proxy.getPath(),proxy.getBox());
	}

	// Show table again
	tree = t;

	// Done
  }        
  /**
   * Tells the ViewInfo to reset made changes
   */
  public void reset() {
	readFromTree();
  }      
  /**
   * Initializes this ViewInfo with the given View
   */
  public void setView(Component comp) throws IllegalArgumentException {

	// Correct type?
	if (!(comp instanceof TreeView))
	  throw new IllegalArgumentException();

	// Calculate Table component & read
	tree = (TreeView)comp;

	readFromTree();

	// Done
  }        
  /**
   * Write changed state to Tree
   */
  private void writeToTree() {

	// Write Options
	tree.setShadow        (checkPaints[0].isSelected());
	tree.setPropertyImages(checkPaints[1].isSelected());
	tree.setZoomBlobs     (checkPaints[2].isSelected());
	tree.setVertical      (checkPaints[3].isSelected());
	tree.setZoom          (scalaZoom.getValue());

	// Write Bookmarks
	ListModel model = listBookmarks.getModel();
	Vector bs = new Vector(model.getSize());
	for (int i=0;i<model.getSize();i++)
	  bs.addElement(model.getElementAt(i));
	tree.setBookmarks(bs);

	// Write Properties
	TagPath[] paths = layoutProperties.getTagPaths();
	Rectangle[] boxes = new Rectangle[paths.length];
	for (int i=0;i<paths.length;i++)
	  boxes[i] = layoutProperties.getBoxForPath(paths[i]);

	Proxy[] proxies = tree.getModel().generateProxies(paths,boxes);
	tree.getModel().setProxiesOf(entity,proxies);
	tree.getModel().setSizeOf(entity,layoutProperties.getSizeOfEntities());

	// Done
  }      
}